<template>
	<AppPage>
		<h1>Add a MaineStreet Course</h1>
		<CourseSelectorMaineStreet @change="selected_course_changed" />
		<b-card bg-variant="danger" v-if="!hasPermission('post:lmsCourse')">
			You are not allowed to add a MaineStreet course.
		</b-card>
		<div
			v-show="selected_course_code.length > 0"
			v-if="hasPermission('post:lmsCourse')"
			id="divAddCourse"
		>
			<b-overlay :show="bs_course_lms_id_fetching">
				<b-card v-show="bs_course_lms_id_fetching" title="Working">
					Getting Course Status in Brightspace
				</b-card>
				<div v-show="!bs_course_lms_id_fetching">
					<b-card
						v-show="course_exists_in_bs"
						title="Course Exists"
						class="m-1"
					>
						<b-link target="_blank" :href="course_url">{{
							selected_course_code
						}}</b-link>
					</b-card>
					<b-card
						v-show="!course_exists_in_bs"
						title="Create Course"
						class="m-1"
					>
						<b-button
							id="btnCreateCourse"
							variant="primary"
							@click.stop.prevent="create_course_in_lms"
							>Create the course in Brightspace</b-button
						>
					</b-card>
				</div>
			</b-overlay>
		</div>
		<AdminHelpTooltip target="divAddCourse" permissions="post:lmsCourse" />
	</AppPage>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
	data() {
		return {};
	},
	computed: {
		...mapGetters({
      selected_course_code: "selected_course_code",
      bs_course_lms_id: "Courses/Add/bs_course_lms_id",
      bs_course_lms_id_fetching: "Courses/Add/bs_course_lms_id_fetching",
      hasPermission: "Navbar/hasPermission",
      lms_url_for_course: "Navbar/lms_url_for_course"
    }),
		course_exists_in_bs() {
			return this.bs_course_lms_id !== null;
		},
		course_url() {
			if (!this.course_exists_in_bs) {
				return "";
			}

			return this.lms_url_for_course(this.bs_course_lms_id);
		}
	},
	methods: {
		...mapActions({get_bs_course_lms_id: "Courses/Add/get_bs_course_lms_id", create_course: "Courses/Add/create_course"}),
		selected_course_changed() {
			if (
				this.selected_course_code.length > 0 &&
				this.hasPermission("post:lmsCourse")
			) {
				this.get_bs_course_lms_id(this.selected_course_code);
			}
		},
		create_course_in_lms() {
			if (this.selected_course_code.length > 0) {
				this.create_course(this.selected_course_code);
			}
		}
	},
	mounted() {
		this.selected_course_changed();
	}
};
</script>
